package logevent.demo2.refactored;

import org.apache.hadoop.mapred.JobConf;
import org.apache.hadoop.mapred.FileInputFormat;
import org.apache.hadoop.mapred.FileOutputFormat;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.mapred.JobClient;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;

public class LogEventCountDriver {
   public static void main(String[] args) throws Exception { 

      JobConf conf = new JobConf(LogEventCountDriver.class);
      conf.setJobName("Log Event Counter");

      FileInputFormat.addInputPath(conf, new Path(args[0]));
      FileOutputFormat.setOutputPath(conf, new Path(args[1]));

      conf.setMapperClass(LogEventParseMapper.class);
      conf.setReducerClass(LogEventSumReducer.class);
      conf.setOutputKeyClass(Text.class); 
      conf.setOutputValueClass(IntWritable.class);

      JobClient.runJob(conf);
   }
}