package logevent.demo5.minicluster;


import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileInputFormat;
import org.apache.hadoop.mapred.FileOutputFormat;
import org.apache.hadoop.mapred.JobClient;
import org.apache.hadoop.mapred.JobConf;

public class LogEventCountDriver {
	public static void main(String[] args) throws Exception {
		JobConf conf = new JobConf(LogEventCountDriver.class);
		Path input = new Path(args[0]);
		Path output = new Path(args[1]);

		conf = configureJob(conf, input, output);

		JobClient.runJob(conf);
	}

	// factored out of main method to make it accessible
	// from our integration test
	public static JobConf configureJob(JobConf conf, Path input, Path output) {
		conf.setJobName("Log Event Counter");

		conf.setMapperClass(LogEventParseMapper.class);
		conf.setReducerClass(LogEventSumReducer.class);
		conf.setOutputKeyClass(Text.class);
		conf.setOutputValueClass(IntWritable.class);

		FileInputFormat.addInputPath(conf, input);
		FileOutputFormat.setOutputPath(conf, output);

		return conf;
	}
}