package logevent.demo5.minicluster;

import java.io.IOException;

import logevent.demo5.minicluster.LogParser.Level;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.MapReduceBase;
import org.apache.hadoop.mapred.Mapper;
import org.apache.hadoop.mapred.OutputCollector;
import org.apache.hadoop.mapred.Reporter;

public class LogEventParseMapper extends MapReduceBase implements
		Mapper<LongWritable, Text, Text, IntWritable> {
	
	private LogParser parser;
	
	public LogEventParseMapper() {
		parser = new LogParser();
	}

	@Override
	public void map(LongWritable key, Text value,
			OutputCollector<Text, IntWritable> output, Reporter reporter)
			throws IOException {

		String line = value.toString();
		Level level = parser.parseLine(line);
		
		if (level != null) {
			output.collect(new Text(level.name()), new IntWritable(1));
		}
	}
}