package logevent.demo5.minicluster;

public class LogParser {
	
	enum Level { DEBUG, INFO, WARN, ERROR, FATAL };

	public Level parseLine(String line) {
		// ignore empty lines
		if (line == null || line.trim().isEmpty()) { 
			return null;
		}
		
		String[] fields = line.split(" ");
		
		// ensure line is not malformed
		if (fields.length <= 3) {
			return null;
		}
		
		String levelField = fields[3];
		for (Level level : Level.values()) {
			String levelName = level.name();
			if (levelName.equalsIgnoreCase(levelField)) {
				return level;
			}
		}
		
		return null;
	}

}
