package logevent.demo3.mrunit;

import logevent.demo3.mrunit.LogEventParseMapper;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mrunit.MapDriver;
import org.junit.Before;
import org.junit.Test;

public class MapperTestCase {
	private MapDriver<LongWritable, Text, Text, IntWritable> mapDriver;

	@Before
	public void setUp() throws Exception {
		LogEventParseMapper mapper = new LogEventParseMapper();
		mapDriver = MapDriver.newMapDriver(mapper);
	}

	@Test
	public void testWithWarnEvent() {
		LongWritable key = new LongWritable();
		Text value = new Text("2012-09-06 22:16:49.391 CDT WARN \"My Message\"");

		mapDriver.withInput(key, value);
		mapDriver.withOutput(new Text("WARN"), new IntWritable(1));
		mapDriver.runTest();
	}
	
	@Test
	public void testWithMalformedLine() {
		LongWritable key = new LongWritable();
		Text value = new Text("2012-#$L!ne w@$_C0rrUp+3D");

		mapDriver.withInput(key, value);
		// There is no output in this case
		mapDriver.runTest();
	}
}
