package logevent.demo3.mrunit;

import java.util.ArrayList;
import java.util.List;

import logevent.demo3.mrunit.LogEventSumReducer;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mrunit.ReduceDriver;
import org.junit.Before;
import org.junit.Test;

public class ReducerTestCase {
	private ReduceDriver<Text, IntWritable, Text, IntWritable> reduceDriver;

	@Before
	public void setUp() throws Exception {
		LogEventSumReducer reducer = new LogEventSumReducer();
		reduceDriver = ReduceDriver.newReduceDriver(reducer);
	}

	@Test
	public void testWithWarnEvent() {
		List<IntWritable> values = new ArrayList<IntWritable>();
	    values.add(new IntWritable(1));
	    values.add(new IntWritable(1));
	    values.add(new IntWritable(1));
	    
	    reduceDriver.withInput(new Text("WARN"), values);
	    
	    reduceDriver.withOutput(new Text("WARN"), new IntWritable(3));
	    
	    reduceDriver.runTest();
	}
}
