package logevent.demo4.mrunitintegration;

import logevent.demo4.mrunitintegration.LogEventSumReducer;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mrunit.MapReduceDriver;
import org.junit.Before;
import org.junit.Test;

public class MapReduceTestCase {
	private MapReduceDriver<LongWritable, Text, Text, IntWritable, Text, IntWritable> mrDriver;

	@Before
	public void setUp() throws Exception {
		LogEventParseMapper mapper = new LogEventParseMapper();
		LogEventSumReducer reducer = new LogEventSumReducer();
		mrDriver = MapReduceDriver.newMapReduceDriver(mapper, reducer);
	}

	@Test
	public void testWithWarnEvent() {
		mrDriver.addInput(new LongWritable(), new Text("2012-09-06 22:16:49.391 CDT WARN \"My Message\""));
		mrDriver.addInput(new LongWritable(), new Text("2012-09-06 22:16:51.121 CDT INFO \"My Message\""));
		mrDriver.addInput(new LongWritable(), new Text("2012-09-06 22:16:52.414 CDT INFO \"My Message\""));
		mrDriver.addInput(new LongWritable(), new Text("2012-09-06 22:16:53.745 CDT DEBUG \"My Message\""));
		mrDriver.addInput(new LongWritable(), new Text("2012-09-06 22:16:53.219 CDT INFO \"My Message\""));
		mrDriver.addInput(new LongWritable(), new Text("2012-09-06 22:16:55.149 CDT WARN \"My Message\""));

		// order matters by default (like a real job, keys are sorted),  
		// though you can specify 'false' to runTest to disable this.
		mrDriver.withOutput(new Text("DEBUG"), new IntWritable(1));
		mrDriver.withOutput(new Text("INFO"), new IntWritable(3));
		mrDriver.withOutput(new Text("WARN"), new IntWritable(2));		
		
		mrDriver.runTest();
	}
}
